#Running custom per-step commands.

execute if score Cyclops Cyclops matches 1..20 run particle dust{color:[0.0,0.0,1.0],scale:1} ~ ~ ~ 0.2 0.2 0.2 0 1 force
execute if score Cyclops Cyclops matches 21..40 run particle dust{color:[0.14,0.0,0.86],scale:1} ~ ~ ~ 0.2 0.2 0.2 0 1 force
execute if score Cyclops Cyclops matches 41..60 run particle dust{color:[0.28,0.0,0.72],scale:1} ~ ~ ~ 0.2 0.2 0.2 0 1 force
execute if score Cyclops Cyclops matches 61..80 run particle dust{color:[0.40,0.0,0.60],scale:1} ~ ~ ~ 0.2 0.2 0.2 0 1 force
execute if score Cyclops Cyclops matches 81..100 run particle dust{color:[0.54,0.0,0.46],scale:1} ~ ~ ~ 0.2 0.2 0.2 0 1 force
execute if score Cyclops Cyclops matches 101..120 run particle dust{color:[0.68,0.0,0.32],scale:1} ~ ~ ~ 0.2 0.2 0.2 0 1 force
execute if score Cyclops Cyclops matches 121..140 run particle dust{color:[0.82,0.0,0.18],scale:1} ~ ~ ~ 0.2 0.2 0.2 0 1 force
execute if score Cyclops Cyclops matches 141.. run particle dust{color:[0.96,0.0,0.04],scale:1} ~ ~ ~ 0.2 0.2 0.2 0 1 force

#Check if an entity was detected.

execute if score #hit cyclopsray matches 0 positioned ~-0.05 ~-0.05 ~-0.05 as @e[tag=!cyclops,dx=0,limit=1,sort=nearest] run function cyclops:check_hit_entity

#Run a function if a block was successfully detected.

execute unless block ~ ~ ~ #cyclops:blocks run function cyclops:hit_block
scoreboard players add #distance cyclopsray 1

#If the raycast failed, run a function with the custom commands.

execute if score #hit cyclopsray matches 0 if score #distance cyclopsray matches 1035.. run function cyclops:failed

#Advance forward and run the ray again if no entity and/or block was found.

execute if score #hit cyclopsray matches 0 if score #distance cyclopsray matches ..1034 positioned ^ ^ ^0.3 run function cyclops:ray